#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fun>
#include <hamsandwich>

#define VERSION "1.4"

new g_enable, knife_fight, g_maxplayers, g_IsBot[33],
g_msgsync, g_PlayerWeapons[33], g_playername[33][32]

public plugin_init()
{
	register_plugin("Knife Fight", VERSION, "alan_el_more")
	register_cvar("kf_version", VERSION, FCVAR_SERVER|FCVAR_SPONLY)
	register_dictionary("Knife_Fight.txt")
	g_enable = register_cvar("kf_enable", "1")
	register_clcmd("say /kf", "cmdkf", ADMIN_KICK)
	register_clcmd("buy", "block_buy")
	register_clcmd("buyammo1", "block_buy")
	register_clcmd("buyammo2", "block_buy")
	register_clcmd("buyequip", "block_buy")
	register_clcmd("cl_autobuy", "block_buy")
	register_clcmd("cl_rebuy", "block_buy")
	register_clcmd("cl_setautobuy", "block_buy")
	register_clcmd("cl_setrebuy", "block_buy")
	register_event("HLTV", "event_round_start", "a", "1=0", "2=0")
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn_Post", 1)
	RegisterHam(Ham_Touch, "weaponbox", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "armoury_entity", "fw_TouchWeapon")
	RegisterHam(Ham_Touch, "weapon_shield", "fw_TouchWeapon")
	g_msgsync = CreateHudSyncObj()
	g_maxplayers = get_maxplayers()
}

public cmdkf(id, level, cid)
{
	if(get_pcvar_num(g_enable))
	{
		if (!cmd_access(id, level, cid, 1))
			return PLUGIN_HANDLED
		
		if(knife_fight)
		{
			set_hudmessage(255, 0, 0, 0.3, 0.0, 1, 0.0, 5.0, 1.0, 1.0, -1)
			ShowSyncHudMsg(0, g_msgsync, "[KF] %L", LANG_PLAYER, "HUD_DISABLE", g_playername[id])
			
			knife_fight = false
			
			for(new id = 1;id <= g_maxplayers;id++)
			{
				if(is_user_alive(id))
					restore_weapons(id)
			}
		}
		else
		{
			set_hudmessage(255, 0, 0, 0.3, 0.0, 1, 0.0, 5.0, 1.0, 1.0, -1)
			ShowSyncHudMsg(0, g_msgsync, "[KF] %L", LANG_PLAYER, "HUD_ENABLE", g_playername[id])
			
			knife_fight = true
			
			for(new id = 1;id <= g_maxplayers;id++)
			{
				if(is_user_alive(id))
				{
					g_PlayerWeapons[id] = pev( id , pev_weapons ) &~ ( 1 << 31 )
					
					strip_user_weapons(id)
					give_item(id, "weapon_knife")
				}
			}
		}		
	}
	else
		client_print(id, print_chat, "[KF] %L", id, "KF_DISABLE")
	
	return PLUGIN_CONTINUE
}

public event_round_start()
{
	if(knife_fight)
	{
		set_hudmessage(255, 0, 0, 0.4, 0.0, 1, 0.0, 5.0, 1.0, 1.0, -1)
		ShowSyncHudMsg(0, g_msgsync, "[KF] %L", LANG_PLAYER, "HUD_KF")
	}
}

// Ham Player Spawn Post Forward
public fw_PlayerSpawn_Post(id)
{
	// Not Alive
	if (!is_user_alive(id))
		return
	
	if(get_pcvar_num(g_enable) && knife_fight)
	{
		strip_user_weapons(id)
		give_item(id, "weapon_knife")
	}
}

public fw_TouchWeapon(weapon, id)
{
	if (knife_fight && (1 <= id <= g_maxplayers) && !g_IsBot[id])
		return HAM_SUPERCEDE
	
	return HAM_IGNORED
}

public client_putinserver(id)
{
	g_IsBot[id] = is_user_bot(id)
	
	get_user_name(id, g_playername[id], charsmax(g_playername[]))
}

public client_infochanged(id)
	get_user_name(id, g_playername[id], charsmax(g_playername[]))

public block_buy(id)
{
	return (knife_fight) ? PLUGIN_HANDLED : PLUGIN_CONTINUE
}

public restore_weapons(id)
{
	new iValue = g_PlayerWeapons[id]
	
	for(new j = 1 ; j <= 30 ; j++)
	{
		if ((1 & (iValue >> j)) && (j != 2) && (j != CSW_C4) && (j != CSW_KNIFE))
		{
			static szWeapon[32]
			get_weaponname(j, szWeapon, 31)
			give_item(id, szWeapon)
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang3082\\ f0\\ fs16 \n\\ par }
*/
