#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

new gCvar_Enabled;
new g_ButtonsCount;
new Array:g_aButtons;

public plugin_init( ) {
	register_plugin( "Reset Buttons", "1.1", "xPaw" );
	
	gCvar_Enabled = register_cvar( "sv_reset_buttons", "1" );
	
	register_event( "HLTV", "evNewRound", "a", "1=0", "2=0" );
}

public plugin_end( )
	ArrayDestroy( g_aButtons );

public plugin_precache( ) {
	g_aButtons = ArrayCreate();
	
	RegisterHam( Ham_Spawn, "func_button", "fwdHamSpawnButton" );
}

public fwdHamSpawnButton( iButton ) {
	ArrayPushCell( g_aButtons, iButton );
	g_ButtonsCount++;
}

public evNewRound( ) {
	if( !get_pcvar_num( gCvar_Enabled ) )
		return PLUGIN_CONTINUE;
	
	for( new i = 0; i < g_ButtonsCount; i++ )
		dllfunc( DLLFunc_Think, ArrayGetCell( g_aButtons, i ) );
	
	return PLUGIN_CONTINUE;
}
