#include <amxmodx>
#include <fakemeta>
#include <cstrike>
#include <fun>

#define PLUGIN "Slap In Round End"
#define VERSION "0.1"
#define AUTHOR "Ninja"

#define TASK_ID 1337

//Globals
new bool:g_round_started;

new
g_roundtime1,
g_roundtime2,
g_roundtime3,
g_adv_time1,
g_adv_time2,
g_adv_time3;

//Cvars
new
toggle_plugin,
g_show_adv1,
g_show_adv2,
g_show_adv3,
g_slay_players;

public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_logevent("round_start", 2, "1=Round_Start");
	register_logevent("round_end", 2, "1=Round_End");
	
	register_event("TextMsg", "round_restart", "a", "2&#Game_C", "2&#Game_w");
	
	register_message(get_user_msgid("RoundTime"), "Round_Timer");
	
	toggle_plugin = register_cvar("amx_roundend","1");
	g_show_adv1 = register_cvar("amx_roundend_adv_30","1");
	g_show_adv2 = register_cvar("amx_roundend_adv_10","1");
	g_show_adv3 = register_cvar("amx_roundend_adv_end","1");
	g_slay_players = register_cvar("amx_roundend_sp","3");
}

public round_start() {
	g_round_started = true;
}

public round_end()
	remove_task(TASK_ID);

public round_restart()
	remove_task(TASK_ID);

public Round_Timer()
{
	if(g_round_started)
		g_round_started = false;
	else
		return;
	
	g_roundtime1 = get_msg_arg_int(1);
	g_adv_time1 = (g_roundtime1 - 31);
	
	g_roundtime2 = get_msg_arg_int(1);
	g_adv_time2 = (g_roundtime2 - 11);
	
	g_roundtime3 = get_msg_arg_int(1);
	g_adv_time3 = (g_roundtime3 - 1);
	
	if(get_pcvar_num(toggle_plugin))
	{
		set_task(float(g_roundtime1), "force_end",TASK_ID);
		if(get_pcvar_num(g_show_adv1))
		{
			set_task(float(g_adv_time1), "show_adv1",TASK_ID);
		}
	
		set_task(float(g_roundtime2), "force_end",TASK_ID);
		if(get_pcvar_num(g_show_adv2))
		{
			set_task(float(g_adv_time2), "show_adv2",TASK_ID);
		}
	
		set_task(float(g_roundtime3), "force_end",TASK_ID);
		if(get_pcvar_num(g_show_adv3))
		{
			set_task(float(g_adv_time3), "show_adv3",TASK_ID);
		}
	}
}

public force_end()
{
	new g_players[32], num;
	get_players(g_players, num);
	
	new x;
	new slay_players = get_pcvar_num(g_slay_players)
	for(new i = 0; i < num; i++)
	{
		x = g_players[i];
		if ( slay_players == 1 )
		{
			user_silentkill(x);
			cs_set_user_deaths(x, get_user_deaths(x) - 1);
		}
		else if ( get_user_team(x) == slay_players - 1 )
		{
			user_silentkill(x);
			cs_set_user_deaths(x, get_user_deaths(x) - 1);		
		}
	}
}

public show_adv1()
{
	set_hudmessage(0, 255, 0, -1.0, -1.0, 1, 6.0, 3.0,_,_,-1);
	show_hudmessage(0, "30 Seconds until round end!");
}

public show_adv2()
{
	set_hudmessage(255, 255, 0, -1.0, -1.0, 1, 6.0, 3.0,_,_,-1);
	show_hudmessage(0, "10 Seconds until round end!");
}

public show_adv3()
{
	set_hudmessage(255, 0, 0, -1.0, -1.0, 1, 6.0, 3.0,_,_,-1);
	show_hudmessage(0, "Round End!");
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1049\\ f0\\ fs16 \n\\ par }
*/
